splash = {}

function splash.enter(game)
    transition_time = 0
    medium_font = g.newFont(45)

    screen_w = 800
    screen_h = 600

    --love_img = g.newImage("assets/images/Love-logo.png")
    love_img = game.preloaded_images['Love-logo.png']
    code_fantasts_img = game.preloaded_images['splashscreen.png']

    --fantasts_sound = love.audio.newSource("assets/sound/splashscreen.wav")
    fantasts_sound = game.preloaded_sounds['splashscreen.wav']
    sound_played = false
    splash_done = false
end

function splash.isDone()
    return splash_done
end

function splash.draw()
    if splash_done then
        return
    end
    g.push()

    if transition_time < 4 then
        if transition_time < 1 then
            local alpha = cap(255*transition_time, 0,255)

            g.setColor(255, 255, 255, 255)
            g.setFont(medium_font)
            g.print("Made using:", (screen_w / 2)-150, (screen_h / 2)-150)
            g.draw(love_img, (screen_w / 2)-(love_img:getWidth()/2), (screen_h / 2)-(love_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)
        elseif transition_time > 3 then
            local alpha = cap(255*(1-(transition_time-3)), 0,255)
            g.setColor(255, 255, 255, 255)
            g.setFont(medium_font)
            g.print("Made using:", (screen_w / 2)-150, (screen_h / 2)-150)
            g.draw(love_img, (screen_w / 2)-(love_img:getWidth()/2), (screen_h / 2)-(love_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)
        else
            local alpha = 255


            g.setColor(255, 255, 255, 255)
            g.setFont(medium_font)
            g.print("Made using:", (screen_w / 2)-150, (screen_h / 2)-150)
            g.draw(love_img, (screen_w / 2)-(love_img:getWidth()/2), (screen_h / 2)-(love_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)
        end
    elseif transition_time < 8 then
        if transition_time < 5 then
			local alpha = cap(255*(transition_time-4), 0,255)

            g.setColor(255, 255, 255, 255)
            g.draw(code_fantasts_img, (screen_w / 2)-(code_fantasts_img:getWidth()/2), (screen_h / 2)-(code_fantasts_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)
		elseif transition_time > 7 then
            local alpha = cap(255*(1-(transition_time-7)), 0,255)

            g.setColor(255, 255, 255, 255)
            g.draw(code_fantasts_img, (screen_w / 2)-(code_fantasts_img:getWidth()/2), (screen_h / 2)-(code_fantasts_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)

		else
            local alpha = 255

            g.setColor(255, 255, 255, 255)
            g.draw(code_fantasts_img, (screen_w / 2)-(code_fantasts_img:getWidth()/2), (screen_h / 2)-(code_fantasts_img:getHeight()/2))

            g.setColor(0, 0, 0, 255-alpha)
            g.rectangle("fill", 0, 0, 800, 600)

            if transition_time > 5 and sound_played == false then
                sound_played = true
                love.audio.play(fantasts_sound)
            end
		end
    else
        splash_done = true
    end

	g.pop()
end

function splash.update(dt)
    transition_time = transition_time + dt
end

function splash.keypressed(key, scancode, isrepeat)
    if transition_time < 4 then
        if transition_time < 1 then
            transition_time = 2
        elseif transition_time > 3 then
            transition_time = 4
        else
            transition_time = 4
        end
    elseif transition_time < 8 then
        if transition_time < 5 then
            sound_played = true
            transition_time = 5
        elseif transition_time > 7 then
            transition_time = 8
        else
            transition_time = 8
        end
    end
end
