local Printer = class("Printer", Base):include(Stateful)

function Printer:initialize(game)
    self.game = game

    self.bg = self.game.preloaded_images['printer_bg.png']
    self.printer_img = self.game.preloaded_images['printer_with_paper_top.png']
    self.printer_bottom = self.game.preloaded_images['printer_bottom.png']

    self.printer_backside_box = self.game.preloaded_images['printer_backside_box.png']
    self.printer_backside_box_plugged = self.game.preloaded_images['printer_backside_box_plugged.png']

    self.printer_firmware_update_box = self.game.preloaded_images['printer_firmware_box_update.png']
    self.printer_firmware_box1 = self.game.preloaded_images['printer_firmware_box1.png']
    self.printer_firmware_box2 = self.game.preloaded_images['printer_firmware_box2.png']
    self.printer_firmware_lines = self.game.preloaded_images['lcd_box_lines.png']

    self.printer_lcd_box = self.game.preloaded_images['printer_lcd_box.png']

    self.power_plug_head = self.game.preloaded_images['power_cable_head.png']
    self.power_plug_part = self.game.preloaded_images['power_cable_part.png']

    self.cursor = self.game.preloaded_images['cursor.png']
    self.hatch_open = self.game.preloaded_images['hatch_open.png']
    self.hatch_open_no_inkt = self.game.preloaded_images['hatch_open_no_inkt.png']

    self.stuck_paper = {
        self.game.preloaded_images['paper_stuck.png'],
        self.game.preloaded_images['paper_stuck_b1.png'],
        self.game.preloaded_images['paper_stuck_b2.png'],
        self.game.preloaded_images['paper_stuck_b3.png']
    }

    self.paper_piece = self.game.preloaded_images['paper_piece.png']

    self.paper_break_sound = self.game.preloaded_sounds['hit.wav']
    self.hit_sound = self.game.preloaded_sounds['hit2.wav']
    self.hit2_sound = self.game.preloaded_sounds['hit3.wav']
    self.btn_sound = self.game.preloaded_sounds['btn_hover.wav']
    self.wifi_done_sound = self.game.preloaded_sounds['wifi_done.wav']

    self.battle_music = self.game.preloaded_sounds['Battle.ogg']
    self.power_drain = self.game.preloaded_sounds['PowerDrain.ogg']

    self.broken_inkt = self.game.preloaded_images['inkt_cartridge_broken.png']

    self.papers = {
        self.game.preloaded_images['printed_paper_1.png'],
        self.game.preloaded_images['printed_paper_2.png'],
        self.game.preloaded_images['printed_paper_3.png']
    }

    self.pentagram = self.game.preloaded_images['pentagram.png']
    self.throw_star = self.game.preloaded_images['throw_star.png']

    self.print_sound = self.game.preloaded_sounds['engine_loop.wav']
    self.print_sound:setVolume(0.25)
    self.print_sound:setLooping(true)

    self.printed_papers = {}

    self.lcd = LCD:new(game, 0, 0)

    self.exorcism_happend = false
    self.lastProblem = 'NoPaper'

    self:gotoState("NoPaper") -- start on the Menu state
end

function Printer:isHatchOpen()
    return false
end

function Printer:setInktHover(val)
    return false
end

function Printer:draw()
    self.lcd:draw()
end

function Printer:update(dt)
end

function Printer:mousemoved(x, y, dx, dy)
end

function Printer:mousereleased(x, y, button, isTouch)
end

function Printer:mousepressed(x, y, button, isTouch)
end

function Printer:keypressed(key, scancode, isrepeat)
end

function Printer:keyreleased(key, scancode)
end

function Printer:handleGameOver()
end

return Printer
