g = love.graphics
math.randomseed(os.time())

screen_w = 800
screen_h = 600

function lerp(a, b, t) return a + (b - a) * t end
function math.round(n, deci) deci = 10^(deci or 0) return math.floor(n*deci+.5)/deci end
function math.clamp(low, n, high) return math.min(math.max(low, n), high) end
function pointInCircle(circle, point) return (point.x-circle.x)^2 + (point.y - circle.y)^2 < circle.radius^2 end
function pointInCircleCords(x, y, center_x, center_y, radius)
    return ((x-center_x)^2) + ((y-center_y)^2) < (radius^2)
end
function string:split(sep) return self:match((self:gsub("[^"..sep.."]*"..sep, "([^"..sep.."]*)"..sep))) end
globalID = 0
function math.dist(x1,y1, x2,y2) return ((x2-x1)^2+(y2-y1)^2)^0.5 end
function generateID() globalID = globalID + 1 return globalID end
function is_func(f) return type(f) == "function" end
function is_num(n) return type(n) == "number" end
function is_string(s) return type(s) == "string" end

function has_value (tab, val)
    for index, value in ipairs (tab) do
        if value == val then
            return true
        end
    end

    return false
end

function inside_btn(x, y, startx, starty, btn_width, btn_height)
    if x >= startx and x <= startx + btn_width then
        if y >= starty and y <= starty + btn_height then
            return true
        end
    end

    return false
end

function round(num, idp)
    local mult = 10^(idp or 0)
    return math.floor(num * mult + 0.5) / mult
end

class = require 'lib.middleclass'
Stateful = require 'lib.stateful'
cron = require 'lib.cron'

Base = require("base")
Game = require("game")
Printer = require("printer")
LCD = require("lcd")

local function require_all(directory)
  require_table = {}
  local lfs = love.filesystem
  for index,filename in ipairs(lfs.getDirectoryItems(directory)) do
    local file = directory .. "/" .. filename
    if lfs.isFile(file) and file:match("%.lua$") then
      require_table[file:gsub("%.lua", "")] = require(file:gsub("%.lua", ""))
    elseif lfs.isDirectory(file) then
      require_all(file)
    end
  end
  return require_table
end

Gamestates = require_all("states")

require("util")
require("lib.splash")
