local Printer_State = Game:addState("Printer_State")

local printer_obj
function Printer_State:enteredState()
    g.setDefaultFilter('nearest', 'nearest', 0)

    printer = Printer:new(self)

    paper_stack = self.preloaded_images['paper_stack.png']
    paper_icon_hover = false
    paper_icon_draging = false
    transition_time = 0

    game_over_time = 0
    game_over = false

    mouse_x = 0
    mouse_y = 0

    paper_tray_start_x = 235
    paper_tray_start_y = 60
    paper_tray_width = 330
    paper_tray_height = 150

    inkt = self.preloaded_images['inkt_cartridge.png']
    inkt_icon_hover = false
    inkt_icon_draging = false

    old_inkt_startx = 237
    old_inkt_starty = 324
    old_inkt_width = 28
    old_inkt_height = 55

    pages_printed = 0

    minutes_left = 2
    seconds_left = 50

    countdown_enabled = true

    space_pressed = false
    back_to_menu = false
    back_to_menu_time = 0

    punsBad = {
        "Wow printing is not your thing",
        "Wow you are kind of doooooomed",
        "Wow lets hope they wont notice",
        "You suck, 0 out of 10 would not print again",
        "You have no idea what your doing..",
        "You failed... Printing is not your thing",
        "Are you this bad or just pretending?",
        "Did you pass out? you needed to print stuff",
        "Wow thats bad... Better buy a new printer",
        "Well at least you tried",
        "Wow a world record! For worst printing job!",
        "Lets pretend it was bad luck and try again"
    }

    punBad = punsBad[ math.random(#punsBad) ]

    punsBetter = {
        "A they wont miss the last pages",
        "The last pages werent important anyway",
        "Well its at least a the important pages",
        "They wont notice a few pages missing",
        "Lets hope for the best",
        "Well at least is more then 5 pages",
        "A well its something",
        "Its most of it.. i guess",
        "You did it!.. mostly",
        "You did it!.. Kind of.. not really",
        "A well its most of it",
        "A well you did the best you could"
    }

    punBetter = punsBetter[ math.random(#punsBetter) ]

    punsGood = {
        "Wow you did good its almost complete!",
        "Wow you did better then i thought",
        "Its almost everthing!",
        "its so many pages they will get it",
        "If they dont like this then to bad",
        "I did it mom!",
        "I'm the almost best at printing!",
        "Well its more then 10!",
        "You can be proud!"
    }

    punGood = punsGood[ math.random(#punsGood) ]

    punsReallyGood = {
        "I even printed the refrences!",
        "I even printed the footnotes!",
        "I am the best at printing!",
        "They will be so impressed!",
        "Take that stupid printer!",
        "You are godlike.. at printing!",
        "Your parents would be proud!",
        "More than 15 pages! WOW",
        "Its amost a hole encyclopedia!",
        "You won.. at printing",
        "Well done. You did good",
        "Well done. Take a cookie",
        "Well done. Im proud",
        "Guiness world record!",
        "You are the best!",
        "write it in the history books!",
        "You are the king! of printing"
    }

    punReallyGood = punsReallyGood[ math.random(#punsReallyGood) ]

    countdown_timer = cron.every(1, function()
        if countdown_enabled then
            seconds_left = seconds_left - 1
            if seconds_left < 0 then
                minutes_left = minutes_left - 1
                if minutes_left < 0 then
                    self:activeGameOver()
                else
                    seconds_left = 60
                end
            end
        end
    end)
end

function Printer_State:setCountdownEnabled(val)
    countdown_enabled = val
end

function Printer_State:activeGameOver()
    game_over_time = transition_time
    game_over = true
    printer:handleGameOver()
end

function Printer_State:addPaper()
    pages_printed = pages_printed + 1
end

function Printer_State:draw()
    g.setColor(255, 255, 255, 255)

    printer:draw()
    --g.rectangle('fill', 235, 60, 330, 150)

    if not printer:hasPaper() then
        if paper_icon_draging then
            love.mouse.setVisible(false)
            if mouse_x >= paper_tray_start_x and mouse_x <= paper_tray_start_x + paper_tray_width then
                if mouse_y >= paper_tray_start_y and mouse_y <= paper_tray_start_y + paper_tray_height then
                    printer:setPaperHover(true)
                else
                    g.draw(paper_stack, mouse_x, mouse_y, 0, 0.75, 0.75, (paper_stack:getWidth()*0.75)/2, (paper_stack:getHeight()*0.75)/2)
                    printer:setPaperHover(false)
                end
            else
                g.draw(paper_stack, mouse_x, mouse_y, 0, 0.75, 0.75, (paper_stack:getWidth()*0.75)/2, (paper_stack:getHeight()*0.75)/2)
                printer:setPaperHover(false)
            end
            g.setColor(255, 255, 255, 128)
        else
            printer:setPaperHover(false)
        end
    --]]

        g.draw(paper_stack, (screen_w-(paper_stack:getWidth()*((paper_icon_hover and not paper_icon_draging) and 0.75 or 0.5)))-10, (screen_h-(paper_stack:getHeight()*((paper_icon_hover and not paper_icon_draging) and 0.75 or 0.5))), 0, ((paper_icon_hover and not paper_icon_draging) and 0.75 or 0.50), ((paper_icon_hover and not paper_icon_draging) and 1.0 or 0.50))
        g.setColor(255, 255, 255, 255)
    end

    if not printer:hasInkt() then
        if inkt_icon_draging then
            love.mouse.setVisible(false)
            if mouse_x >= old_inkt_startx and mouse_x <= old_inkt_startx + paper_tray_width then
                if mouse_y >= old_inkt_starty and mouse_y <= old_inkt_starty + paper_tray_height then
                    if printer:setInktHover(true) then

                    else
                        g.draw(inkt, mouse_x, mouse_y, 0, 1, 1, inkt:getWidth()/2, (inkt:getHeight()/2))
                        g.setColor(255, 255, 255, 128)
                        printer:setInktHover(false)
                    end
                else
                    g.draw(inkt, mouse_x, mouse_y, 0, 1, 1, inkt:getWidth()/2, (inkt:getHeight()/2))
                    g.setColor(255, 255, 255, 128)
                    printer:setInktHover(false)
                end
            else
                g.draw(inkt, mouse_x, mouse_y, 0, 1, 1, inkt:getWidth()/2, (inkt:getHeight()/2))
                g.setColor(255, 255, 255, 128)
                printer:setInktHover(false)
            end
        end

        g.draw(inkt, (0+inkt:getWidth()), screen_h-inkt:getHeight(), 0, 1, 1)
        g.setColor(255, 255, 255, 255)
    end

    --g.print("Paper hover: "..tostring(paper_icon_hover), 25, 25)

    local alpha = cap(255*transition_time, 0,255)
    g.setColor(0, 0, 0, 255-alpha)
    g.rectangle("fill", 0, 0, screen_w, screen_h)

    if not game_over then
        g.setColor(255, 0, 0, 255)
        g.setFont(self.preloaded_fonts["04b03_24"])
        local minuteStr = (minutes_left < 10 and "0"..tostring(minutes_left) or tostring(minutes_left))
        local secondStr = (seconds_left < 10 and "0"..tostring(seconds_left) or tostring(seconds_left))
        g.print("Time left: " .. minuteStr .. ":" .. secondStr, screen_w - 200, 5)
        g.print("Pages printed: " .. tostring(pages_printed), screen_w - 225, 25)
    end

    if game_over then
        local time_since_game_over = transition_time - game_over_time
        local alpha = cap(128*time_since_game_over, 0,128)
        g.setColor(0, 0, 0, alpha)
        g.rectangle("fill", 0, 0, screen_w, screen_h)
        g.setColor(255, 255, 255, 255)

        g.setFont(self.preloaded_fonts["04b03_46"])
        g.print("GAME OVER", (screen_w/2) - 125, 250)

        g.setFont(self.preloaded_fonts["04b03_36"])
        g.print("You printed: " .. tostring(pages_printed) .. " pages!", (screen_w/2) - 200, 300)

        g.setFont(self.preloaded_fonts["04b03_16"])

        if pages_printed < 8 then
            g.print(punBad, (screen_w/2) - ((#punBad)*4), 350)
        elseif pages_printed >= 8 and pages_printed < 16 then
            g.print(punBetter, (screen_w/2) - ((#punBetter)*4), 350)
        elseif pages_printed >= 16 and pages_printed < 20 then
            g.print(punGood, (screen_w/2) - ((#punGood)*4), 350)
        elseif pages_printed >= 20 then
            g.print(punReallyGood, (screen_w/2) - ((#punReallyGood)*4), 350)
        end

        local bstr = "Press <space> to go back the the menu"
        g.print(bstr, (screen_w/2) - ((#bstr)*4.5), 380)

        if back_to_menu then
            local time_since_back_to_menu = transition_time - back_to_menu_time
            local alpha = cap(255*time_since_back_to_menu, 0,255)
            g.setColor(0, 0, 0, alpha)
            g.rectangle("fill", 0, 0, screen_w, screen_h)
        end
    end
end

function Printer_State:mousereleased(x, y, button, isTouch)
    if not game_over then
        if not printer:hasPaper() then
            if paper_icon_draging then
                if mouse_x >= paper_tray_start_x and mouse_x <= paper_tray_start_x + paper_tray_width then
                    if mouse_y >= paper_tray_start_y and mouse_y <= paper_tray_start_y + paper_tray_height then
                        if not printer:hasPaper() then
                            printer:gotoState("WithPaper")
                        end
                    end
                end
                paper_icon_draging = false
                love.mouse.setVisible(true)
            end
        end

        if not printer:hasInkt() then
            if inkt_icon_draging then

                inkt_icon_draging = false
                love.mouse.setVisible(true)
            end
        end

        printer:mousereleased(x, y, button, isTouch)
    end
end

function Printer_State:mousepressed(x, y, button, isTouch)
    if not game_over then
        if button == 1 then
            if paper_icon_hover then
                paper_icon_draging = true
                love.mouse.setVisible(false)
            end

            if inkt_icon_hover then
                inkt_icon_draging = true
                love.mouse.setVisible(false)
            end
        end

        printer:mousepressed(x, y, button, isTouch)
    end
end

function Printer_State:mousemoved(x, y, dx, dy)
    mouse_x = x
    mouse_y = y

    if not game_over then
        if not printer:hasPaper() then
            local paper_icon_startx = (screen_w-(((paper_icon_hover and not paper_icon_draging) and (paper_stack:getWidth()*0.75) or paper_stack:getWidth()*0.5)))
            local paper_icon_starty = (screen_h-(((paper_icon_hover and not paper_icon_draging) and (paper_stack:getHeight()*0.75) or paper_stack:getHeight()*0.5)))
            --local paper_icon_starty = ((screen_h-200)-((playbtn_hover and (playbtn:getHeight()*1.5) or playbtn:getHeight())/2))
            if x >= paper_icon_startx and x <= paper_icon_startx + (((paper_icon_hover and not paper_icon_draging) and (paper_stack:getWidth()*0.75) or paper_stack:getWidth()*0.5)) then
                if y >= paper_icon_starty and y <= paper_icon_starty + (((paper_icon_hover and not paper_icon_draging) and (paper_stack:getHeight()*0.75) or paper_stack:getHeight()*0.5)) then
                    paper_icon_hover = true
                else
                    paper_icon_hover = false
                end
            else
                paper_icon_hover = false
            end
        else
            paper_icon_hover = false
            paper_icon_draging = false
        end

        if not printer:hasInkt() then
            --g.draw(inkt, (0+(inkt:getWidth()*((inkt_icon_hover and not inkt_icon_draging) and 1.5 or 0.75))), (screen_h-(inkt:getHeight()*((inkt_icon_hover and not inkt_icon_draging) and 1.5 or 0.75))), 0, ((inkt_icon_hover and not inkt_icon_draging) and 1.5 or 0.75), ((inkt_icon_hover and not inkt_icon_draging) and 1.5 or 0.75))

            local inkt_icon_startx = (0+inkt:getWidth())
            local inkt_icon_starty = (screen_h-inkt:getHeight())
            --local paper_icon_starty = ((screen_h-200)-((playbtn_hover and (playbtn:getHeight()*1.5) or playbtn:getHeight())/2))
            if x >= inkt_icon_startx and x <= inkt_icon_startx + (((inkt_icon_hover and not inkt_icon_draging) and (inkt:getWidth()*1.5) or inkt:getWidth()*0.75)) then
                if y >= inkt_icon_starty and y <= inkt_icon_starty + (((inkt_icon_hover and not inkt_icon_draging) and (inkt:getHeight()*1.5) or inkt:getHeight()*1.5)) then
                    inkt_icon_hover = true
                else
                    inkt_icon_hover = false
                end
            else
                inkt_icon_hover = false
            end
        else
            inkt_icon_hover = false
            inkt_icon_draging = false
        end

        printer:mousemoved(x, y, dx, dy)
    end
end

function Printer_State:update(dt)
    transition_time = transition_time + dt

    if not game_over then
        countdown_timer:update(dt)
        printer:update(dt)

        if inkt_icon_draging or paper_icon_hover then
            love.mouse.setVisible(false)
        end
    else
        if back_to_menu then
            local time_since_back_to_menu = transition_time - back_to_menu_time
            local fade_check = cap(258*time_since_back_to_menu, 0,258)

            if fade_check == 258 then
                self:gotoState("Menu")
            end
        end
    end
end

function Printer_State:keypressed(key, scancode, isrepeat)
    if not game_over then
        printer:keypressed(key, scancode, isrepeat)
    else
        if key == "space" then
            space_pressed = true
        end
    end
end

function Printer_State:keyreleased(key, scancode)
    if not game_over then
        printer:keyreleased(key, scancode)
    else
        if key == "space" and space_pressed and not back_to_menu then
            back_to_menu = true
            back_to_menu_time = transition_time
        end
    end
end

function Printer_State:exitedState()

end
