local Normal = LCD:addState("Normal")

function Normal:enteredState()
    animation_time = 0

    self.prev_state = self.cur_state
    self.cur_state = "Normal"

    self.prev_img = self.cur_img
    self.cur_img = self.text1_lcd
    animation_time = 0

    power_animation_done = false
end

function Normal:draw()
    g.setColor(255, 0, 0, 255)
    --g.print("PREV STATE: " .. self.prev_state, 75, 75)
    g.setColor(255, 255, 255, 255)

    if self.prev_state == "NoPower" and not power_animation_done then
        local fade = cap(255*(animation_time*1.5), 0,255)
        if fade < 255 then
            g.setColor(255, 255, 255, 255)
            g.draw(self.prev_img, self.lcd_x, self.lcd_y, 0, 1, 1)
            g.setColor(255, 255, 255, 255-fade)
            g.draw(self.prev_img, self.lcd_x, self.lcd_y, 0, 1, 1)
            g.setColor(255, 255, 255, fade)
            g.draw(self.cur_img, self.lcd_x, self.lcd_y, 0, 1, 1)
            g.setColor(255, 255, 255, 255)
        else
            power_animation_done = true
            animation_time = 0
        end
    else
        local s = math.sin(animation_time*2.0)
        --g.setColor(0, 255, 0, 255)
        --g.print("sin : " .. tostring(s), 75, 75)
        g.setColor(255, 255, 255, 255)
        if s > 0 then
            self.cur_img = self.text1_lcd
            g.draw(self.text1_lcd, self.lcd_x, self.lcd_y, 0, 1, 1)
        else
            self.cur_img = self.text2_lcd
            g.draw(self.text2_lcd, self.lcd_x, self.lcd_y, 0, 1, 1)
        end
        g.setColor(255, 255, 255, 255)
    end
end

function Normal:update(dt)
    animation_time = animation_time + dt
end

return Warning
