local NoPaper = Printer:addState("NoPaper")

function NoPaper:enteredState()
    printer_img = self.game.preloaded_images['printer_normal_no_paper.png']
    printer_with_paper = self.game.preloaded_images['printer_with_paper.png']

    paper_hover = false
end

function NoPaper:setPaperHover(hover)
    paper_hover = hover
end

function NoPaper:hasPaper()
    return false
end

function NoPaper:hasInkt()
    return true
end

function NoPaper:draw()
    if paper_hover then
        g.draw(printer_with_paper, 0, 0, 0, 1, 1)
    else
        g.draw(printer_img, 0, 0, 0, 1, 1)
    end
    g.setColor(255, 255, 255, 255)

    g.setColor(255, 0, 0, 255)
    local bstr = "No paper! Quick put the paper in!"
    g.print(bstr, (screen_w/2) - ((#bstr)*4.5)-100, screen_h-30)
    g.setColor(255, 255, 255, 255)
    self.lcd:draw()
end

function NoPaper:update(dt)
    love.mouse.setVisible(true)
end

return NoPaper
