local WithPaper = Printer:addState("WithPaper")

function WithPaper:enteredState()
    animation_time = 0
    total_time = 0
    paper = nil

    highest_chance = 0.85
    lowest_chance = 0.20
    current_chance = lowest_chance

    self.lcd:gotoState("Normal")

    self.print_sound:play()

    problems = {
        "Exorcism",
        "Firmware",
        "NoInkt",
        "NoPowerCable",
        "PaperStuck",
        "NoWifi"
    }
end

function WithPaper:handleGameOver()
    self.print_sound:stop()
end

function WithPaper:hasPaper()
    return true
end

function WithPaper:hasInkt()
    return true
end

function WithPaper:isHatchOpen()
    return false
end

function WithPaper:setPaperHover(hover)
    paper_hover = hover
end

function WithPaper:draw()
    g.setColor(255, 255, 255, 255)
    g.draw(self.bg, 0, 0, 0, 1, 1)
    xr = (math.random()*2.5)

    self.lcd:setPrinterCoords(0+xr, 0)
    g.draw(self.printer_bottom, 0+xr, 0, 0, 1, 1)

    if animation_time < 14 then
        if paper == nil then
            paper = self.papers[math.random(#self.papers)]
        end

        local ys = cap(1*(animation_time*0.15), 0,1)
        local movement = cap(255*(animation_time*0.15), 0,255)

        for i,v in ipairs(self.printed_papers) do
            g.draw(v.paper, v.x+xr, v.y, 0, 1, 1, v.paper:getWidth()/2)
        end

        g.draw(paper, 400+xr, (435 - (255-movement))+(ys == 1 and 10 or 0), 0, ys, ys, paper:getWidth()/2)

        if ys == 1 then
            table.insert(self.printed_papers, {
                paper = paper,
                x = 400,
                y = (435 - (255-movement))+(ys == 1 and 10 or 0)
            })

            paper = self.papers[math.random(#self.papers)]
            self.game:addPaper()
            animation_time = 0
        end
    end

    g.draw(self.printer_img, 0+xr, 0, 0, 1, 1)

    local event_ys = cap(1*(total_time*0.30), 0,1)

    g.setColor(255, 0, 0, 255)
    --g.print("event ys: " .. tostring(event_ys), 25, 75)
    --g.print("ys time: " .. tostring(ys), 25, 95)
    g.setColor(255, 255, 255, 255)
    self.lcd:draw()
end

function WithPaper:update(dt)
    animation_time = animation_time + dt
    total_time = total_time + dt

    local ys = cap(1*(total_time*0.30), 0,1)

    local random = math.random()

    love.mouse.setVisible(true)

    --[[
    if round(ys,1) == 0.5 then
        if random < current_chance then
            -- We got a problem
            current_chance = lowest_chance
            problem = problems[ math.random( #problems ) ]
            while (problem == 'Exorcism' and self.exorcism_happend ) do
                problem = problems[ math.random( #problems ) ]
            end

            while (problem == self.lastProblem) do
                problem = problems[ math.random( #problems ) ]
            end

            self.lastProblem = problem
            self:gotoState(problem)
        end
    end
    --]]

    if ys == 1 then
        if random < current_chance then
            -- We got a problem
            current_chance = lowest_chance
            problem = problems[ math.random( #problems ) ]

            while ((problem == 'Exorcism' and self.exorcism_happend) or (problem == self.lastProblem)) do
                problem = problems[ math.random( #problems ) ]
            end

            self.lastProblem = problem
            self.print_sound:stop()
            self:gotoState(problem)
        else
            current_chance = current_chance + 0.05
            if current_chance > highest_chance then
                current_chance = highest_chance
            end

            total_time = 0
        end
    end

    self.lcd:update(dt)
end

return WithPaper
